#include <iostream> ///          ,      
#include <cstring>
#include <cstdlib>
#include <ctime>

using namespace std;
int result_count = 0; ///,       
int N; ///    ,   
int **Board; ///     
int M; ///   

///  
void showBoard(string F) ///   
{
    for(int i = 0; i < M; ++i) /// ,    
    {
        for(int j = 0; j < M; ++j)  /// ,    
            cout << ((Board[i][j]) ? F : "."); ///  ,    ,      
        cout << endl;                          /// -    ,  -      
    }
    cout << "Result # " << ++result_count << "\n\n"; ///         
    return;
}

///     

bool tryQueen(int a, int b) ///        , a-  , b-  
{
    for (int i = 0; i < M; ++i) ///    
    {
        if(Board[a][i])
            return false;
    }

    for(int i = 0; i < M; ++i) ///    
    {
        if(Board[i][b])
            return false;
    }

    for(int i = 1; a-i >= 0 && b-i >= 0; ++i)///     -
    {
        if(Board[a-i][b-i])
            return false;
    }

    for(int i = 1; a+i < M && b+i < M; ++i)///     -
    {
        if(Board[a+i][b+i])
            return false;
    }

    for(int i = 1; a+i < M && b-i >= 0; ++i)///     -
    {
        if(Board[a+i][b-i])
            return false;
    }

    for(int i = 1; a-i >= 0 && b+i < M; ++i)///     -
    {
        if(Board[a-i][b+i])
            return false;
    }

    return true; ///        ,      
}

void setQueen(int a, int count) ///  ; a -  , count -   ,   
{
    for(int b = 0; b < M; ++b) ///b -  ,    
    {
        if(tryQueen(a, b)) ///      
        {
            Board[a][b] = 1; ///     ,    1 (true)

            for(int i = a + 1; i < M; ++i) ///    
                setQueen(i,count+1);

            if(count+1 == N) ///     , 
                showBoard("Q"); ///       

            Board[a][b]=0; ///        
        }
    }
}

///     

bool tryRook(int a, int b) ///        , a-  , b-  
{
    for (int i = 0; i < M; ++i) ///    
    {
        if(Board[a][i])
            return false;
    }

    for(int i = 0; i < M; ++i) ///    
    {
        if(Board[i][b])
            return false;
    }

    return true; ///        ,      
}

void setRook(int a, int count) ///  ; a -  , count -   ,   
{
    for(int b = 0; b < M; ++b) ///b -  ,    
    {
        if(tryRook(a, b)) ///      
        {
            Board[a][b] = 1; ///    ,    1 (true)

            for(int i = a + 1; i < M; ++i) ///    
                setRook(i,count+1);

            if(count+1 == N) ///     , 
                showBoard("R"); ///       

            Board[a][b]=0; ///        
        }
    }
}

///     

bool tryEl(int a, int b) ///        , a-  , b-  
{
    for(int i = 1; a-i >= 0 && b-i >= 0; ++i)///     -
    {
        if(Board[a-i][b-i])
            return false;
    }

    for(int i = 1; a+i < M && b+i < M; ++i)///     -
    {
        if(Board[a+i][b+i])
            return false;
    }

    for(int i = 1; a+i < M && b-i >= 0; ++i)///     -
    {
        if(Board[a+i][b-i])
            return false;
    }

    for(int i = 1; a-i >= 0 && b+i < M; ++i)///     -
    {
        if(Board[a-i][b+i])
            return false;
    }

    return true; ///        ,      
}
void setEl(int dia, int count) ///  ; line -  , count -   ,   
{
    ///dia -  ,        
    int a, b; ///,    , a-  , b-  

    if (dia < M) ///,  a     
    {
        a = dia; ///  ,    
        b = 0; ///   ,    
    }
   else /// a       (      
     {
        a = M-1; ///  
        b =(dia % M)+1; ///      
     }

    for(int i=0; a-i>=0 && b+i < M; ++i)///          
    {
        int line = a-i; ///    
        int column = b+i; ///    

        if(tryEl(line, column))///      
        {
            Board[line][column]=1; ///    ,    1 (true)

            for(int i = dia + 1; i<2*M-1; ++i) ///    
                setEl(i,count+1);

            if(count+1 == N) ///     , 
                showBoard("E"); ///       

            Board[line][column]=0; ///        
        }
    }
}

///     

bool tryHorse(int a, int b) ///        , a-  , b-  
{
    ///        8 ,        55   

    if ((a-1) >=0 && (b-2)>=0 && Board[a-1][b-2])
        return false;

    if ((a-1)>=0 && (b+2) < M && Board[a-1][b+2])
        return false;

    if ((a+1) < M && (b-2) >=0 && Board[a+1][b-2])
        return false;

    if ((a+1) < M && (b+2) < M && Board[a+1][b+2])
        return false;

    if ((a-2) >=0 && (b-1) >=0 && Board[a-2][b-1])
        return false;

    if ((a-2) >=0 && (b+1) < M && Board[a-2][b+1])
        return false;

    if ((a+2) < M && (b-1) >= 0 && Board[a+2][b-1])
        return false;

    if ((a+2) < M && (b+1) < M && Board[a+2][b+1])
        return false;

    return true; ///        ,      
}

void setHorse(int count, int a, int b) ///  ; a -  , b -  , count -   ,   
{
    if(count==N) ///     , 
    {
        showBoard("H");  ///       
    }

    if (a == M) /// ;     
        return;

    for (int j=b; j<M; ++j) ///    
    {
        if(tryHorse(a, j)) ///      
        {
            Board[a][j]=1; ///    ,    1 (true)
            int line = a, b = j+1; ///      ,    line

            if (b == M) ///   -  
            {
                b = 0; /// ,       
                line++;     ///        
            }
            setHorse(count+1,line,b); /// ,  
            Board[a][j]=0; ///        
        }
    }

    for(int i=a+1; i<M; ++i) ///   
    {
        for (int j=0; j<M; ++j)
        {
            if(tryHorse(i, j)) ///      
            {
                Board[i][j]=1; ///    ,    1 (true)
                int line = i, b = j+1; ///      

                if (b == M) ///   -  
                {
                    b = 0;
                    line++;  ///        
                }
                setHorse(count+1,line,b); /// ,  
                Board[i][j]=0;  ///        
            }
        }
    }
}

/// 

bool tryKing(int a, int b) ///        33, a-  , b-  
{
 ///        8 ,        33   

    for(int i = a-1; i <= a+1; ++i) ///  
    {
        for(int j = b-1; j <= b+1; ++j) ///  
        {
            if (a>=0 && a < M && b>=0 && b < M && Board[a][b]) ///     
                return false;

            if ((a+1) < M && (b-1) >=0 && Board[a+1][b-1])
                return false;

            if ((a+1) < M && Board[a+1][b])
                return false;

            if ((a+1) < M && (b+1) < M && Board[a+1][b+1])
                return false;

            if ((b+1) < M && Board[a][b+1])
                return false;

            if ((a-1)>=0 && (b+1) < M && Board[a-1][b+1])
                return false;

            if ((a-1) >=0 && Board[a-1][b])
                return false;

            if ((a-1) >=0 && (b-1)>=0 && Board[a-1][b-1])
                return false;

            if ((b-1) >= 0 && Board[a][b-1])
                return false;
        }
    }

    return true; ///        ,      
}

void setKing (int count, int a, int b) ///  ; a -  , b -  , count -    ,   
{
    for (int j=b; j<M; ++j)  ///    
    {
        if(tryKing(a, j)) ///      
        {
            Board[a][j]=1; ///      
            setKing(count+1,a,j); ///    
            Board[a][j]=0;  ///        
        }
    }

    for(int i=a+1; i<M; ++i) ///        
    {
        for (int j=0; j<M; ++j)
        {
            if(tryKing(i, j)) ///      
            {
                Board[i][j]=1; ///      
                setKing(count+1,i,j); /// 
                Board[i][j]=0;  ///        
            }
        }
    }

    if(count==N) ///     , 
    {
        showBoard("K");///       
        return;
    }
}

int main()
{
    char s; ///,    
    do      /// ,           
    {
        do ///      
        {
            cout << "Input the size of the board: " << endl; ///  
            cin >> M;

            if ( (M%2) == 1) ///,     ,     
            {
                cout << '\n' << "The number must be even, so try to input the size again" << '\n' << endl;
            }

        }
        while (M%2 !=0); ///    c ,   

        Board = new int*[M];  ///      
        for (int i = 0; i<M; i++)
            Board[i] = new int[M]; ///   
        for (int i = 0; i<M; i++)
            for (int j = 0; j<M; j++)
                Board[i][j] = 0;  /// 

        int V; ///       
        cout << '\n' << "Input your choice: 1=placing of figures, 2=for max amount of figures" << endl;
        cin >> V;

        if (V==1) ///,      
        {
            char k; ///,    
            do      /// ,           
            {
                int T; ///  
                cout << '\n' << "Input type of figure: 1-queen, 2-king, 3-horse, 4-rook, 5-elephant"<< endl;
                cin >> T;

                int maximum; ///,    ,      
                if (T==1) ///       
                {
                    maximum=M;
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                }
                if (T==2) ///       
                {
                    maximum=0.25*M*M;
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                }
                if (T==3) ///       
                {
                    maximum=0.5*M*M;
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                }
                if (T==4) ///       
                {
                    maximum=M;
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                }
                if (T==5) ///       
                {
                    maximum=2*M-2;
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                }

                do ///,   ,  
                {
                    cout << "Input the amount of figures, it must be less than max amount or equals that" << endl;
                    cin >> N;
                }
                while (N>maximum);   ///    c ,   

                cout << '\n' << "All possible variants for this amount of figures on this board:" << '\n' << endl;

                if (T==1) ///,            
                {
                    result_count=0; /// ,   ;     
                    for (int i=0; i <M; ++i)
                        setQueen(i,0);
                }
                if (T==2) ///,            
                {
                    result_count=0; /// ,   ;     
                    setKing(0,0,0);
                }
                if (T==3) ///,            
                {
                    result_count=0; /// ,   ;     
                    setHorse(0,0,0);
                }
                if (T==4) ///,            
                {
                    result_count=0; /// ,   ;     
                    for (int i=0; i <M; ++i)
                        setRook(i,0);
                }
                if (T==5) ///,            
                {
                    result_count=0; /// ,   ;     
                    for(int i = 0; i<2*M-1; ++i)
                        setEl(i,0);
                }

                cout << '\n' << "If you want continue placing figures, input +, if not, input -" << endl;
                cin >> k;
            }
            while (k != '-'); ///    ,        
        }

        else if (V==2) ///,        
        {
            char z; ///,    
            do      /// ,           
            {
                int T; ///    
                cout << '\n' << "Input type of figure: 1-queen, 2-king, 3-horse, 4-rook, 5-elephant"<< endl;
                cin >> T;
                char d;  ///,    
                int maximum; ///,    ,      
                if (T==1) ///       
                {
                    maximum=M; ///       
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                    cout << "If you want to see all locations of max amount, input +, if not, input -" << endl;
                    cin >> d;
                    cout << '\n' << "All possible variants for this amount of figures on this board:" << '\n' << endl;
                    if (d=='+') ///            
                    {
                        result_count=0; /// ,   ;     
                        N=maximum; ///      ,    
                        for (int i=0; i < M; ++i)
                            setQueen(i,0);
                    }

                }
                if (T==2) ///       
                {
                    maximum=0.25*M*M; ///       
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                    cout << "If you want to see all locations of max amount, input +, if not, input -" << endl;
                    cin >> d;
                    cout << '\n' << "All possible variants for this amount of figures on this board:" << '\n' << endl;
                    if (d=='+') ///            
                    {
                        result_count=0; /// ,   ;     
                        N=maximum; ///      ,    
                        setKing(0,0,0);
                    }
                }
                if (T==3) ///       
                {
                    maximum=0.5*M*M; ///       
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                    cout << "If you want to see all locations of max amount, input +, if not, input -" << endl;
                    cin >> d;
                    cout << '\n' << "All possible variants for this amount of figures on this board:" << '\n' << endl;
                    if (d=='+') ///            
                    {
                        result_count=0; /// ,   ;     
                        N=maximum; ///      ,    
                        setHorse(0,0,0);
                    }
                }
                if (T==4) ///       
                {
                    maximum=M; ///       
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                    cout << "If you want to see all locations of max amount, input +, if not, input -" << endl;
                    cin >> d;
                    cout << '\n' << "All possible variants for this amount of figures on this board:" << '\n' << endl;
                    if (d=='+') ///            
                    {
                        result_count=0; /// ,   ;     
                        N=maximum; ///      ,    
                        for (int i=0; i <M; ++i)
                            setRook(i,0);
                    }
                }
                if (T==5) ///       
                {
                    maximum=2*M-2; ///       
                    cout << '\n' << "Max amount of figures for this board = " << maximum << '\n' << endl;
                    cout << "If you want to see all locations of max amount, input +, if not, input -" << endl;
                    cin >> d;
                    cout << '\n' << "All possible variants for this amount of figures on this board:" << '\n' << endl;
                    if (d=='+') ///            
                    {
                        result_count=0; /// ,   ;     
                        N=maximum; ///      ,    
                        for(int i = 0; i<2*M-1; ++i)
                            setEl(i,0);
                    }
                }

                cout << '\n' << "If you want continue counting, input +, if not, input -" << '\n' << endl;
                cin >> z;
            }
            while (z != '-'); ///    ,        
        }
        cout << '\n' << "If you want to change the size of board, input +, if not, input -" << endl;
        cin >> s;
        if (s=='-')
        {
            cout << '\n' << "The program is finished." << '\n' << endl; ///       
        }
    }
    while (s != '-'); ///    ,        ,      
}
